//
//  HaplessViewController.m
//  Hapless
//
//  Created by Jp on 3/11/11.
//  Copyright 2011 Jp4Mobile. All rights reserved.
//

/**
 * This is called Hapless, because it's an example of all the problems that are
 * sadly, very easy to create with xcode, if you're not very familiar with the
 * IDE.
 */

#import "HaplessViewController.h"

@implementation HaplessViewController

// This ties the attributes of the class (the _<variable names> to the @property
// declarations

@synthesize infoLabel    = _infoLabel;
@synthesize nameField    = _nameField;
@synthesize emailField   = _emailField;
@synthesize cancelButton = _cancelButton;
@synthesize submitButton = _submitButton;

- (void)dealloc
{
    // There are several ways of accessing the underlying variables, which I 
    // will use here. They are equivalent.
    [self.infoLabel      release];
    [[self nameField]    release];
    [_emailField         release];
    [self.cancelButton   release];
    [[self submitButton] release];
    
    // It's always important to call the parent class' dealloc to make sure that
    // everything is cleaned out properly.
    [super dealloc];
}

- (void)didReceiveMemoryWarning
{
    // Releases the view if it doesn't have a superview.
    [super didReceiveMemoryWarning];
    
    // Release any cached data, images, etc that aren't in use.
}

#pragma mark - View lifecycle

/*
// Implement viewDidLoad to do additional setup after loading the view, typically from a nib.
- (void)viewDidLoad
{
    [super viewDidLoad];
}
*/

- (void)viewDidUnload
{
    [super viewDidUnload];
    // Release any retained subviews of the main view.
    // e.g. self.myOutlet = nil;
}

- (BOOL)shouldAutorotateToInterfaceOrientation:(UIInterfaceOrientation)interfaceOrientation
{
    // Return YES for supported orientations
    return (interfaceOrientation == UIInterfaceOrientationPortrait);
}

#pragma -
#pragma Button Functions
- (IBAction) cancelPressed:(id)sender {
    // This basically does some trivial things in the case of the cancel 
    // button being pressed.
    // The following are equivalent, feel free to uncomment the various lines
    // to play with them.
    self.infoLabel.text = @"Cancel Button Pressed";
    //    [[self infoLabel] setText:@"Cancel Button Pressed"];
    NSLog(@"This is about to crash. Can you tell why?");
    // We expect an object and give it nothing. This generates a warning on compilation, but 
    // unfortunately, it doesn't stop you.
    NSLog(@"It's simple enough. Look: --> %@");
    // The correct log statement would be something like this:
    //    NSLog(@"It's simple enough. Look: --> %@", NULL);
    // Yep, you can log a NULL pointer in Objective-C.
    return;
}

- (IBAction) submitPressed:(id)sender {
    // Log some information
    NSLog(@"submitPressed - sender (%@) nameField (%@) emailField (%@)",
          sender, self.nameField.text, self.emailField.text);
    self.infoLabel.text = @"Submit Button Pressed";
    return;
}


@end
