//
//  ModalExampleViewController.m
//  ModalExample
//
//  Created by Jp on 4/6/11.
//  Copyright 2011 Jp4Mobile. All rights reserved.
//

#import "ModalExampleViewController.h"

@implementation ModalExampleViewController

@synthesize modalVC             = _modalVC;
@synthesize transitionsPicker   = _transitionsPicker;
@synthesize transitionNamesList = _transitionNamesList;

- (void)dealloc
{
    [self.transitionNamesList release];
    
    [super dealloc];
}

- (void)didReceiveMemoryWarning
{
    // Releases the view if it doesn't have a superview.
    [super didReceiveMemoryWarning];
    
    // Release any cached data, images, etc that aren't in use.
}

#pragma mark - View lifecycle

/* */
// Implement viewDidLoad to do additional setup after loading the view, typically from a nib.
- (void)viewDidLoad
{
    [super viewDidLoad];
    
    self.transitionNamesList = [NSArray arrayWithObjects:@"CoverVertical", @"FlipHorizontal", @"CrossDissolve", @"PartialCurl", nil];
}
/* */

- (void)viewDidUnload
{
    [super viewDidUnload];
    // Release any retained subviews of the main view.
    // e.g. self.myOutlet = nil;
}

- (BOOL)shouldAutorotateToInterfaceOrientation:(UIInterfaceOrientation)interfaceOrientation
{
    // Return YES for supported orientations
    return (interfaceOrientation == UIInterfaceOrientationPortrait);
}

#pragma mark -
#pragma mark Button Functions
- (IBAction) alertMe:(id)sender {
    NSLog(@"alertMe pressed by (%@)", sender);
    
	UIAlertView *alert = [[UIAlertView alloc] initWithTitle:@"Alert" 
													message:@"You pressed the alert button. Ta da!"
												   delegate:nil
										  cancelButtonTitle:@"Dismiss" 
										  otherButtonTitles:nil];
	[alert show];
	[alert release];
}

- (IBAction) modalViewMe:(id)sender {
    NSLog(@"modalViewMe pressed by (%@)", sender);
    // Choose the transition...
    // There's only one so we don't need to check anything else...
    switch ([self.transitionsPicker selectedRowInComponent:0]) {
        case 0:
            self.modalVC.modalTransitionStyle = UIModalTransitionStyleCoverVertical;
            break;
        case 1:
            self.modalVC.modalTransitionStyle = UIModalTransitionStyleFlipHorizontal;
            break;
        case 2:
            self.modalVC.modalTransitionStyle = UIModalTransitionStyleCrossDissolve;
            break;
        case 3:
            self.modalVC.modalTransitionStyle = UIModalTransitionStylePartialCurl;
            break;
        default:
            NSLog(@"Nothing selected");
            break;
    }
    
    // This is where the magic happens to display a modal view
    [self presentModalViewController:self.modalVC animated:YES];
}

#pragma mark - UIPickerViewDataSource
- (NSInteger)numberOfComponentsInPickerView:(UIPickerView *)pickerView {
    // We only need one component
    return 1;
}

- (NSInteger)pickerView:(UIPickerView *)pickerView numberOfRowsInComponent:(NSInteger)component {
    // How many items are there in the array?
    return [self.transitionNamesList count];
}

#pragma mark - UIPickerViewDelegate

- (NSString *)pickerView:(UIPickerView *)pickerView titleForRow:(NSInteger)row forComponent:(NSInteger)component {
    return [self.transitionNamesList objectAtIndex:row];
}

@end
