//
//  SecondViewController.m
//  TabFun
//
//  Created by Jp on 4/6/11.
//  Copyright 2011 Jp4Mobile. All rights reserved.
//

#import "ColorPickerViewController.h"
#import "ColorHelper.h"

@implementation ColorPickerViewController

@synthesize colorPicker = _colorPicker;
@synthesize colorArray  = _colorArray;

/* */
// Implement viewDidLoad to do additional setup after loading the view, typically from a nib.
- (void)viewDidLoad
{
    [super viewDidLoad];
    
    self.colorArray = [NSArray arrayWithObjects:[ColorHelper colorWithName:@"Red" color:[UIColor redColor]], [ColorHelper colorWithName:@"Orange" color:[UIColor orangeColor]], [ColorHelper colorWithName:@"Yellow" color:[UIColor yellowColor]], [ColorHelper colorWithName:@"Green" color:[UIColor greenColor]], [ColorHelper colorWithName:@"Blue" color:[UIColor blueColor]], [ColorHelper colorWithName:@"Purple" color:[UIColor purpleColor]], nil];
}
/* */

- (BOOL)shouldAutorotateToInterfaceOrientation:(UIInterfaceOrientation)interfaceOrientation
{
    // Return YES for supported orientations
    return (interfaceOrientation == UIInterfaceOrientationPortrait);
}


- (void)didReceiveMemoryWarning
{
    // Releases the view if it doesn't have a superview.
    [super didReceiveMemoryWarning];
    
    // Release any cached data, images, etc. that aren't in use.
}


- (void)viewDidUnload
{
    [super viewDidUnload];

    // Release any retained subviews of the main view.
    // e.g. self.myOutlet = nil;
}


- (void)dealloc
{
    [self.colorArray release];
    
    [super dealloc];
}

#pragma mark - UIPickerViewDataSource
- (NSInteger)numberOfComponentsInPickerView:(UIPickerView *)pickerView {
    // We only need one component
    return 1;
}

- (NSInteger)pickerView:(UIPickerView *)pickerView numberOfRowsInComponent:(NSInteger)component {
    // How many items are there in the array?
    return [self.colorArray count];
}

#pragma mark - UIPickerViewDelegate

- (NSString *)pickerView:(UIPickerView *)pickerView titleForRow:(NSInteger)row forComponent:(NSInteger)component {
    return [[self.colorArray objectAtIndex:row] colorName];
}

- (void)pickerView:(UIPickerView *)pickerView didSelectRow:(NSInteger)row inComponent:(NSInteger)component {
    NSLog(@"You picked: %@", [[self.colorArray objectAtIndex:row] colorName]);
    // We'll be using NSUserDefault to store the data
    NSUserDefaults *defaults = [NSUserDefaults standardUserDefaults];
    // And here we see the problem with using NSUserDefaults. They can only handle property values.
    // Helper classes can't be stored in this manner...
    // To store something like this, we'll need a way to convert from NSData or NSString back to the helper class...
    [defaults setObject:[self.colorArray objectAtIndex:row] forKey:@"colorResult"];
}

@end
