//
//  RootViewController.m
//  TableFun
//
//  Created by Jp on 3/11/11.
//  Copyright 2011 Jp4Mobile. All rights reserved.
//

#import "RootViewController.h"
#import "ColorHelper.h"
#import "CustomColorCell.h"

@implementation RootViewController

@synthesize colorList      = _colorList;
@synthesize listOfSwitches = _listOfSwitches;

- (void)viewDidLoad
{
    // Populate our colorList
    //    self.colorList = [NSArray arrayWithObjects:@"Red", @"Orange", @"Yellow", @"Green", @"Blue", @"Indigo", @"Violet", nil];
    //    self.colorList = [NSArray arrayWithObjects:[UIColor redColor], [UIColor orangeColor], [UIColor yellowColor], [UIColor greenColor], [UIColor blueColor], [UIColor purpleColor], nil];
    NSMutableArray * tmpList = [[NSMutableArray alloc] init];
    
    ColorHelper * colorRec = [[ColorHelper alloc] init];
    colorRec.colorName  = @"Red";
    colorRec.colorColor = [UIColor redColor];
    [tmpList addObject:colorRec];
    
    colorRec = [[ColorHelper alloc] init];
    colorRec.colorName  = @"Orange";
    colorRec.colorColor = [UIColor orangeColor];
    [tmpList addObject:colorRec];
    
    colorRec = [[ColorHelper alloc] init];
    colorRec.colorName  = @"Yellow";
    colorRec.colorColor = [UIColor yellowColor];
    [tmpList addObject:colorRec];
    
    colorRec = [[ColorHelper alloc] init];
    colorRec.colorName  = @"Green";
    colorRec.colorColor = [UIColor greenColor];
    [tmpList addObject:colorRec];
    
    colorRec = [[ColorHelper alloc] init];
    colorRec.colorName  = @"Blue";
    colorRec.colorColor = [UIColor blueColor];
    [tmpList addObject:colorRec];
    
    colorRec = [[ColorHelper alloc] init];
    colorRec.colorName  = @"Purple";
    colorRec.colorColor = [UIColor purpleColor];
    [tmpList addObject:colorRec];
    
    self.colorList = tmpList;
    
    [tmpList release];
    
    // Allocate an array of all the switches that we'll be fill with the contents of the colorList.
    // We won't be using these, they're space holders that will be switched out with the appropriate UISwitches
    // Watch how we do it in the CellForRow method...
    self.listOfSwitches = [[NSMutableArray alloc] initWithArray:self.colorList copyItems:NO];
    
    [super viewDidLoad];
}

- (void)viewWillAppear:(BOOL)animated
{
    [super viewWillAppear:animated];
}

- (void)viewDidAppear:(BOOL)animated
{
    [super viewDidAppear:animated];
}

- (void)viewWillDisappear:(BOOL)animated
{
	[super viewWillDisappear:animated];
}

- (void)viewDidDisappear:(BOOL)animated
{
	[super viewDidDisappear:animated];
}

/*
 // Override to allow orientations other than the default portrait orientation.
- (BOOL)shouldAutorotateToInterfaceOrientation:(UIInterfaceOrientation)interfaceOrientation {
	// Return YES for supported orientations.
	return (interfaceOrientation == UIInterfaceOrientationPortrait);
}
 */

// Customize the number of sections in the table view.
- (NSInteger)numberOfSectionsInTableView:(UITableView *)tableView
{
    return 1;
}

- (NSInteger)tableView:(UITableView *)tableView numberOfRowsInSection:(NSInteger)section
{
   return [self.colorList count];
    //    return 0;
}

- (CGFloat)tableView:(UITableView *)tableView heightForRowAtIndexPath:(NSIndexPath *)indexPath {
    // We looked up the height of our custom cells in the CustomColorCell.xib file
    return 80.0;
}

// Customize the appearance of table view cells.
- (UITableViewCell *)tableView:(UITableView *)tableView cellForRowAtIndexPath:(NSIndexPath *)indexPath
{
    //    static NSString *CellIdentifier = @"Cell";
    static NSString *CellIdentifier = @"CustomColorCell";
    
    UITableViewCell *cell = [tableView dequeueReusableCellWithIdentifier:CellIdentifier];
    if (cell == nil) {
        //        cell = [[[UITableViewCell alloc] initWithStyle:UITableViewCellStyleDefault reuseIdentifier:CellIdentifier] autorelease];
        cell = [[[NSBundle mainBundle] loadNibNamed:CellIdentifier owner:self options:nil] lastObject];
    }

    // Configure the cell.
    // Pull out the NSStrings from our colorList
    //    cell.textLabel.text = [self.colorList objectAtIndex:indexPath.row];
    //    cell.textLabel.text = @"Colored Text";
    //    cell.textLabel.textColor = [self.colorList objectAtIndex:indexPath.row];
    //    cell.textLabel.text      = [[self.colorList objectAtIndex:indexPath.row] colorName];
    //    cell.textLabel.textColor = [[self.colorList objectAtIndex:indexPath.row] colorColor];
    ColorHelper * colorRec = [self.colorList objectAtIndex:indexPath.row];
    CustomColorCell  * cccell = (CustomColorCell *)cell;
    cccell.colorColor.backgroundColor = colorRec.colorColor;
    cccell.colorName.text             = colorRec.colorName;
    cccell.colorName.textColor        = colorRec.colorColor;
    // Check to see if the UISwitch is in the list of switches
    // If it's not, add it
    if (NSNotFound == [self.listOfSwitches indexOfObject:cccell.hideColorSwitch]) {
        // Grab the UISwitch object and put it in the right portion of the switch array
        [self.listOfSwitches replaceObjectAtIndex:indexPath.row withObject:cccell.hideColorSwitch];
        // That wouldn't be as useful, if we didn't listen for changes on the UISwitch
        // Programmatically, assign a selector...
        [cccell.hideColorSwitch addTarget:self action:@selector(switchValueChanged:) forControlEvents:UIControlEventValueChanged];
    } else {
        // Set the value
        [cccell.hideColorSwitch setOn:[[self.listOfSwitches objectAtIndex:indexPath.row] isOn]];
    }
    // Hide the color block, if switched...
    cccell.colorColor.hidden = !cccell.hideColorSwitch.isOn;
    
    return cell;
}

/*
// Override to support conditional editing of the table view.
- (BOOL)tableView:(UITableView *)tableView canEditRowAtIndexPath:(NSIndexPath *)indexPath
{
    // Return NO if you do not want the specified item to be editable.
    return YES;
}
*/

/*
// Override to support editing the table view.
- (void)tableView:(UITableView *)tableView commitEditingStyle:(UITableViewCellEditingStyle)editingStyle forRowAtIndexPath:(NSIndexPath *)indexPath
{
    if (editingStyle == UITableViewCellEditingStyleDelete)
    {
        // Delete the row from the data source.
        [tableView deleteRowsAtIndexPaths:[NSArray arrayWithObject:indexPath] withRowAnimation:UITableViewRowAnimationFade];
    }
    else if (editingStyle == UITableViewCellEditingStyleInsert)
    {
        // Create a new instance of the appropriate class, insert it into the array, and add a new row to the table view.
    }   
}
*/

/*
// Override to support rearranging the table view.
- (void)tableView:(UITableView *)tableView moveRowAtIndexPath:(NSIndexPath *)fromIndexPath toIndexPath:(NSIndexPath *)toIndexPath
{
}
*/

/*
// Override to support conditional rearranging of the table view.
- (BOOL)tableView:(UITableView *)tableView canMoveRowAtIndexPath:(NSIndexPath *)indexPath
{
    // Return NO if you do not want the item to be re-orderable.
    return YES;
}
*/

- (void)tableView:(UITableView *)tableView didSelectRowAtIndexPath:(NSIndexPath *)indexPath
{
    /*
    <#DetailViewController#> *detailViewController = [[<#DetailViewController#> alloc] initWithNibName:@"<#Nib name#>" bundle:nil];
    // ...
    // Pass the selected object to the new view controller.
    [self.navigationController pushViewController:detailViewController animated:YES];
    [detailViewController release];
	*/
}

- (void)didReceiveMemoryWarning
{
    // Releases the view if it doesn't have a superview.
    [super didReceiveMemoryWarning];
    
    // Relinquish ownership any cached data, images, etc that aren't in use.
}

- (void)viewDidUnload
{
    [super viewDidUnload];

    // Relinquish ownership of anything that can be recreated in viewDidLoad or on demand.
    // For example: self.myOutlet = nil;
}

- (void)dealloc
{
    [super dealloc];
}

- (IBAction) switchValueChanged:(id)sender {
    NSLog(@"switchValueChanged:(%@)", sender);
    
    int rowInSwitchList = [self.listOfSwitches indexOfObject:sender];
    NSLog(@"rowInColorList is %d", rowInSwitchList);
    
    // To make sure that the table updates on switch switching, we need to reload the table...
    [self.tableView reloadData];
}

@end
